/* ***************
// gtafcode.js
// Main implementation file for gtafCode  
//
// Author: Patrick Wildenborg (gtafcode@patrickw.gtagames.nl)
// Contributors:
//   - Jed Brown
//   - Ronny Perinke
//   - Cusser
****************** */
var gtafCode_Color;
var gtafCode_Size;
var gtafCode_Font;
var gPreferences;
var gtafCode_stringBundle;
var gtafCode_Document = null;
var gtafCode_Member_Name;
var gtafCode_Topic_Name;
var gtafCode_Forum_Name;
var gtafCode_Cat_Name;
//Set Defaults
getPrefgtafCodeCompose().SetDefaultCharPref("gtafcode.font.color", "#000000");
getPrefgtafCodeCompose().SetDefaultCharPref("gtafcode.font.size", "12");
getPrefgtafCodeCompose().SetDefaultCharPref("gtafcode.font.face", "times");


var GTAFcode = {
  init: function() {
    gtafCode_setupDocument(document);
    GTAFcode.GetUserPrefs();
    
     try{
      var menu = document.getElementById('contentAreaContextMenu');
      menu.addEventListener('popupshowing', GTAFcode.showHide, false);
    }catch (e){
      //Foobar!
    }
  },
  showHide: function() {
	var show_edit = false;
	var show_member = false;
	var show_topic = false;
	var show_forum = false;
	var show_cat = false;
	var show_default = false;
	var show_search = false;
    if ( ! document.getElementById('context-undo').hidden){
        show_edit = true;
    } else if (window._content.document.location.host == "www.gtaforums.com" ||
	           window._content.document.location.host == "www.gtagarage.com") {
        if (gContextMenu.isTextSelected) {
		    var focusedWindow = document.commandDispatcher.focusedWindow;
		    var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
		    var label = winWrapper.getSelection().toString();
	        //var SelectionText = Selection.toString();
	        if ( label.length > 15 ) {
		        label = label.substring(0,15)+gContextMenu.ellipsis;
	        }
			document.getElementById('context-gtafcode-search').label = "Search \""+ label+"\"";	          
	    
		    show_search = true;      
        } else if (gContextMenu.onLink && 
			        ( (gContextMenu.link.href.indexOf("showuser=") > -1) ||
			          (gContextMenu.link.href.indexOf("act=Profile&CODE=03") > -1) ||       
			          (gContextMenu.link.href.indexOf("http://www.gtagarage.com/users/profile.php?") > -1))) {
			gtafCode_Member_Name = document.popupNode.textContent;	
			var label = gtafCode_Member_Name;          
	        if ( label.length > 15 ) {
		        label = label.substring(0,15)+ gContextMenu.ellipsis;
	        }
			document.getElementById('context-gtafcode-member').label = "Member: "+ label;	          
		    show_member = true;      
	    } else if (gContextMenu.onLink && (gContextMenu.link.href.indexOf("showtopic=") > -1) && !(document.popupNode.textContent == "Posted:")) {
			gtafCode_Topic_Name = document.popupNode.textContent;	          
			var label = gtafCode_Topic_Name;          
	        if ( label.length > 15 ) {
		        label = label.substring(0,15)+ gContextMenu.ellipsis;
	        }
			document.getElementById('context-gtafcode-topic').label = "Topic: "+ label;	          
		    show_topic = true;
	    } else if (gContextMenu.onLink && (gContextMenu.link.href.indexOf("showforum=") > -1)) {
			gtafCode_Forum_Name = document.popupNode.textContent;	          
			var label = gtafCode_Forum_Name;          
	        if ( label.length > 15 ) {
		        label = label.substring(0,15)+ gContextMenu.ellipsis;
	        }
			document.getElementById('context-gtafcode-forum').label = "Forum: "+ label;	          
		    show_forum = true;
	    } else if (gContextMenu.onLink && ((gContextMenu.link.href.indexOf("&c=") > -1)||(gContextMenu.link.href.indexOf("?c=") > -1))) {
			gtafCode_Cat_Name = document.popupNode.textContent;	          
			var label = gtafCode_Cat_Name;          
	        if ( label.length > 15 ) {
		        label = label.substring(0,15)+ gContextMenu.ellipsis;
	        }
			document.getElementById('context-gtafcode-cat').label = "Category: "+ label;	          
		    show_cat = true;
	    } else {
		    show_default = true;
		    
	    }      
    } 
    document.getElementById('context-gtafcode-code').hidden = !show_edit; 
    document.getElementById('context-gtafcode-search').hidden = !show_search; 
    if (show_search) {
	    var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	    var patt2 = new RegExp("showtopic=([0-9]*)", "g");	
	    var patt3 = new RegExp("c=([0-9]*)", "g");
	    var forum_url = "";
	    try{	
		   forum_url = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.href;
		}catch (e){}
        var this_url = window._content.document.location;
		document.getElementById('gtafcode-forumt').hidden = document.getElementById('gtafcode-forump').hidden = !patt1.test(forum_url);
		document.getElementById('gtafcode-forumct').hidden = document.getElementById('gtafcode-forumcp').hidden = !(gContextMenu.onLink && ((gContextMenu.link.href.indexOf("&c=") > -1)||(gContextMenu.link.href.indexOf("?c=") > -1)));
		document.getElementById('gtafcode-forumtt').hidden = document.getElementById('gtafcode-forumtp').hidden = !(gContextMenu.onLink && (gContextMenu.link.href.indexOf("showforum=") > -1));
		document.getElementById('gtafcode-topic').hidden = !patt2.test(this_url);
    }
    if (show_default && !gContextMenu.onLink ) {
	    var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	    var patt2 = new RegExp("showtopic=([0-9]*)", "g");	
	    var patt3 = new RegExp("showuser=([0-9]*)", "g");	
	    var patt4 = new RegExp("[&\?]c=([0-9]*)", "g");	
	    var patt5 = new RegExp("GTAForums.com -> (.*)", "g");	
		var forum_url = "";
		try {
			forum_url = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.href;
		} catch(e){}
        var this_url = window._content.document.location;
        var this_title = window._content.document.title;
		show_forum = patt1.test(forum_url);
		if (show_forum) {
			gtafCode_Forum_Name = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.textContent;
		}
		show_topic = patt2.test(this_url);
		if (show_topic) {
			patt5.test(this_title);
			gtafCode_Topic_Name = RegExp.lastParen
		}
		show_member = patt3.test(this_url);
		if (show_member) {
			gtafCode_Member_Name = window._content.document.getElementById('profilename').textContent;
		}
		show_cat = patt4.test(this_url);
		if (show_cat) {
			patt5.test(this_title);
			gtafCode_Cat_Name = RegExp.lastParen
		}
	    document.getElementById('context-gtafcode-member').label = "This Member";	          
	    document.getElementById('context-gtafcode-forum').label = "This Forum";	          
	    document.getElementById('context-gtafcode-topic').label = "This Topic";	          
	    document.getElementById('context-gtafcode-cat').label = "This Category";	          
    }
    document.getElementById('context-gtafcode-member').hidden = !show_member; 
    document.getElementById('context-gtafcode-topic').hidden = !show_topic; 
    document.getElementById('context-gtafcode-forum').hidden = !show_forum; 
    document.getElementById('context-gtafcode-cat').hidden = !show_cat; 
    document.getElementById('context-gtafcode-default').hidden = !show_default; 
},
  gtafcode: function(myCommand, codeType) {
    var clip = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
    if (!clip){
      return false;
    }
    
    var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
    if (!trans){
      return false;
    }
      trans.addDataFlavor("text/unicode");
      clip.getData(trans,clip.kGlobalClipboard);

    
    var str = null;
    var str_clipboard=new Object();
    var strLength=new Object();
    try{
      trans.getTransferData("text/unicode",str_clipboard,strLength);
  
  
      if (str_clipboard){
        str_clipboard=str_clipboard.value.QueryInterface(Components.interfaces.nsISupportsString);
      }
      if (str_clipboard){
        pastetext=str_clipboard.data.substring(0,strLength.value / 2);
      }
    }catch (e){
      //alert("No text in the clipboard, please copy something first.");
    }
    
    if(codeType == "gtafcode"){
      var theBox = document.commandDispatcher.focusedElement;
      var oPosition = theBox.scrollTop;
      var oHeight = theBox.scrollHeight;
    
    
      //Get Selected text (if selected)
      var startPos = theBox.selectionStart;
      var endPos = theBox.selectionEnd;
      str = theBox.value.substring(startPos, endPos);
        GTAFcode.insertAtCursorSetup(myCommand, str_clipboard, str, theBox);
	}else if(codeType == "gtafsearch"){
	  GTAFcode.gtafsearch(myCommand);  
	}else if(codeType == "gtafmember"){
	  GTAFcode.gtafmember(myCommand);  
	}else if(codeType == "gtaftopic"){
	  GTAFcode.gtaftopic(myCommand);  
	}else if(codeType == "gtafforum"){
	  GTAFcode.gtafforum(myCommand);  
	}else if(codeType == "gtafcat"){
	  GTAFcode.gtafcat(myCommand);  
	}else if(codeType == "gtafdefault"){
	  GTAFcode.gtafdefault(myCommand);  
	}else
	{
	alert("Errort #1#"+codeType);
	}
    var nHeight = theBox.scrollHeight - oHeight;
    theBox.scrollTop = oPosition + nHeight;
  },
  
    insertAtCursorSetup: function(myCommand, str_clipboard, str, theBox) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place
    var select_flag = (str != "")
    switch (myCommand){
      case "pastequote":
        var alertText = gtafCode_stringBundle.getString("gtafcode.quote.attribution");
        var attrib = prompt(alertText);
        if(attrib != null ) {
	        if(attrib != "") attrib = "="+attrib;
	        GTAFcode.insertAtCursor("[quote"+ attrib+"]" + str_clipboard +"[/quote]");
        }
        break;
        
      case "pasteimage":
        GTAFcode.insertAtCursor("[img]" + str_clipboard + "[/img]");
        break;
        
      case "pastecode":
        GTAFcode.insertAtCursor("[code]" + str_clipboard + "[/code]");
        break;     
        
      case "pasteurl":
        GTAFcode.insertAtCursor("[url]" + str_clipboard + "[/url]");
        break;
        
      case "pastelink":
        GTAFcode.insertAtCursorEx("[url=" + str_clipboard + "]" + str,"[/url]",select_flag);
        break;
        
      case "pastespoiler":
        GTAFcode.insertAtCursor("[spoiler]" + str_clipboard + "[/spoiler]");
        break;
        
      case "bold":
        GTAFcode.insertAtCursorEx("[b]" + str ,"[/b]",select_flag);
        break;
        
      case "italic":
        GTAFcode.insertAtCursorEx("[i]" + str,"[/i]",select_flag);
        break;
        
      case "underline":
        GTAFcode.insertAtCursorEx("[u]" + str,"[/u]",select_flag);
        break;
        
      case "strike":
        GTAFcode.insertAtCursorEx("[s]" + str,"[/s]",select_flag);
        break;
        
      case "size":
        var re = [];
        var gtafcodesize = [gtafCode_Size];
        window.openDialog("chrome://gtafcode/content/gtafcodesize.xul", "gtafCodeSize","chrome,modal,centerscreen",re,gtafcodesize);
        if(re[0]){
          GTAFcode.insertAtCursorEx("[size=" + gtafcodesize[0] + "]" + str,"[/size]",select_flag);
          gtafCode_Size = gtafcodesize[0];
        }
        break;

      case "font":
        var re = [];
        var gtafcodeface = [gtafCode_Font];
        window.openDialog("chrome://gtafcode/content/gtafcodefont.xul", "gtafCodeFace","chrome,modal,centerscreen",re,gtafcodeface);
        if(re[0]){
          GTAFcode.insertAtCursorEx("[font=" + gtafcodeface[0] + "]" + str,"[/font]",select_flag);
          gtafCode_Font = gtafcodeface[0];
        }
        break;

      case "color":
        var re = [];
        var gtafcoedcolor = [gtafCode_Color];
        window.openDialog("chrome://gtafcode/content/gtafcodecolor.xul", "gtafCodeColor","chrome,modal,centerscreen",re,gtafcoedcolor);
        if(re[0]){
          GTAFcode.insertAtCursorEx("[color=" + gtafcoedcolor[0] + "]" + str,"[/color]",select_flag);
          gtafCode_Color = gtafcoedcolor[0];
        }
        break;
        
      case "quote":
        var attrib = null;

        if( select_flag ) {
		   var lines = str.split("\n");
           var fields = lines[0].split("|");
	       if (fields.length > 1) attrib = fields[0];
           str = str.substring(str.indexOf('|')+1,str.length);
        } 
	      
        var alertText = gtafCode_stringBundle.getString("gtafcode.quote.attribution");
        if (attrib == null) attrib = prompt(alertText);
        if(attrib != null ) {
	        if(attrib != "") attrib = "="+attrib;
	        GTAFcode.insertAtCursorEx("[quote"+ attrib +"]" + str,"[/quote]",select_flag);
	    }
        break;
        
      case "image":
        GTAFcode.insertAtCursorEx("[img]" + str,"[/img]",select_flag);
        break;
        
      case "url":
        GTAFcode.insertAtCursorEx("[url]" + str,"[/url]",select_flag);
        break;
        
      case "link":
        var alertText = gtafCode_stringBundle.getString("gtafcode.link.url");
        GTAFcode.insertAtCursorEx("[url="+ prompt(alertText)+"]" + str,"[/url]",select_flag);
        break;
        
      case "center":
        GTAFcode.insertAtCursorEx("[center]" + str,"[/center]",select_flag);
        break;
        
      case "spoiler":
        GTAFcode.insertAtCursorEx("[spoiler]" + str,"[/spoiler]",select_flag);
        break;
        
      case "me":
        GTAFcode.insertAtCursorEx("[me]" + str,"[/me]",select_flag);
        break;
        
      case "alignright":
        GTAFcode.insertAtCursorEx("[align=right]" + str,"[/align]",select_flag);
        break;
        
      case "code":
        GTAFcode.insertAtCursorEx("[code]" + str,"[/code]",select_flag);
        break;
 
      case "youtube":
        var alertText = gtafCode_stringBundle.getString("gtafcode.youtube.id");
        GTAFcode.insertAtCursor("[youtube]"+ prompt(alertText)+"[/youtube]");
        break;

      case "anchor":
        var alertText = gtafCode_stringBundle.getString("gtafcode.anchor.name");
        GTAFcode.insertAtCursorEx("[anchor="+ prompt(alertText)+"]" + str,"[/anchor]",select_flag);
        break;

      case "jumpto":
        var alertText = gtafCode_stringBundle.getString("gtafcode.anchor.name");
        GTAFcode.insertAtCursorEx("[jumpto="+ prompt(alertText)+"]" + str,"[/jumpto]",select_flag);
        break;
            
      case "breakquote":
        if ( !select_flag) {
           GTAFcode.insertAtCursorEx("[/quote]","[quote=continued...]",select_flag);
        }
        break;
        
      case "table":
      case "tableb":
        if ( !select_flag )
        {
	        var row = " ";
	        var buffer = "";
	        var line_done = false;
	        while(row != "" && row != null){ 
	          var alertText = gtafCode_stringBundle.getString("gtafcode.table");
	          row = prompt(alertText);
	          if(row != "" && row != null ){
	            buffer += "[tr]"
	            var fields = row.split("|");
	            var field_num=0;
	            while( field_num < fields.length)
	            {
		            if( fields[field_num].charAt(0) == '*' ) {
		                buffer += "[th]"
		                buffer += fields[field_num].substring(1);
		                buffer += " [/th]"
		            } else
		            {
		                buffer += "[td]"
		                buffer += fields[field_num];
		                buffer += " [/td]"
	                }
		            field_num +=1;
	            }
	            buffer += "[/tr]\n"
	            line_done = true;
	          }
	        }
	        if(row != null && line_done){
	          GTAFcode.insertAtCursor("["+myCommand+"]\n" + buffer+"[/"+myCommand+"]");
	        }
        }
        else
        {
	        var lines = str.split("\n");
	        var line_num=0;
	        var buffer = "["+myCommand+"]\n";
	        while (line_num < lines.length)
	        {
	            buffer += "[tr]"
	            var fields = lines[line_num].split("|");
	            var field_num=0;
	            while( field_num < fields.length)
	            {
		            if( fields[field_num].charAt(0) == '*' ) {
		                buffer += "[th]"
		                buffer += fields[field_num].substring(1);
		                buffer += " [/th]"
		            } else
		            {
		                buffer += "[td]"
		                buffer += fields[field_num];
		                buffer += " [/td]"
	                }
		            field_num +=1;
	            }
	            line_num+=1;
	            buffer += "[/tr]\n"
	        }
	        buffer += "[/"+myCommand+"]";
	
	        GTAFcode.insertAtCursor(buffer);
        }
        break;
                
      case "list":
      case "list=1":
      case "list=a":
      case "list=i":
      case "list=I":
        if ( !select_flag )
        {
	        var listElements = " ";
	        var listString = "";
	        var line_done = false;
	        while(listElements != "" && listElements != null){ 
	          var alertText = gtafCode_stringBundle.getString("gtafcode.list");
	          listElements = prompt(alertText);
	          if(listElements != "" && listElements != null ){
	            listString = listString + "\n[*]" +listElements;
	            line_done = true;
	          }
	        }
	        if(listElements != null && line_done){
	          GTAFcode.insertAtCursor("["+myCommand+"]"  + listString + "[/list]");
	        }
        }
        else
        {
	        var lines = str.split("\n");
	        var line_num=0;
	        var buffer = "["+myCommand+"]\n";
	        while (line_num < lines.length)
	        {
	            buffer += "[*]"
	            buffer += lines[line_num]
	            line_num+=1;
	            buffer += "\n"
	        }
	        buffer += "[/list]";
	
	        GTAFcode.insertAtCursor(buffer);
	        
        }
        break;  
      
        //End gtafCODE
        
      default : 
        var alertText = gtafCode_stringBundle.getString("gtafcode.option.err");
        alert(alertText);
        
    }
  },

gtafsearch: function(myCommand) {
    var focusedWindow = document.commandDispatcher.focusedWindow;
	var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
	var Selection = winWrapper.getSelection();
    var SelectionText = Selection.toString();
    

    
    var pattc = new RegExp("showforum=([0-9]*)", "g");	
	
	pattc.test(gContextMenu.link.href);
	var cforum_id = RegExp.lastParen

	
    switch (myCommand){
      case "member":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Members&name_box=contains&name=" + SelectionText;
        break;
        
      case "board":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&forums=all&keywords=" + SelectionText;
        break;
        
      case "forumt":
	    var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	    var forum_url = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.href;
	    patt1.test(forum_url);
	    var forum_id = RegExp.lastParen
	
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&keywords="+SelectionText+"&forums="+forum_id;
        break;   
          
      case "forump":
	    var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	    var forum_url = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.href;
	    patt1.test(forum_url);
	    var forum_id = RegExp.lastParen
	
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&result_type=posts&keywords="+SelectionText+"&forums="+forum_id;
        break;     

      case "forumtt":
        var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	
	    patt1.test(gContextMenu.link.href);
	    var forum_id = RegExp.lastParen
	
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&keywords="+SelectionText+"&forums="+forum_id;
        break;   
          
      case "forumtp":
        var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	
	    patt1.test(gContextMenu.link.href);
	    var forum_id = RegExp.lastParen
	
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&result_type=posts&keywords="+SelectionText+"&forums="+forum_id;
        break;     

     case "forumct":
        var patt1 = new RegExp("c=([0-9]*)", "g");	
	
	    patt1.test(gContextMenu.link.href);
	    var cat_id = RegExp.lastParen
	
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&keywords="+SelectionText+"&forums=c_"+cat_id;
        break;   
          
      case "forumcp":
        var patt1 = new RegExp("c=([0-9]*)", "g");	
	
	    patt1.test(gContextMenu.link.href);
	    var cat_id = RegExp.lastParen
	
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&result_type=posts&keywords="+SelectionText+"&forums=c_"+cat_id;
        break;     
        
      case "topic":
	    var patt1 = new RegExp("showtopic=([0-9]*)", "g");	
	    var patt2 = new RegExp("showforum=([0-9]*)", "g");	
	    var this_url = window._content.document.location;
	    var forum_url = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.href;
		patt1.test(this_url);
	    var topic_id = RegExp.lastParen
	    patt2.test(forum_url);
	    var forum_id = RegExp.lastParen
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&forums="+forum_id+"&result_type=posts&keywords="+SelectionText+"&topic=" + topic_id;
        break;
        
      default : 
        var alertText = gtafCode_stringBundle.getString("gtafcode.option.err");
        alert(alertText);
        
    }
  },
gtafmember: function(myCommand) {
	var patt1 = new RegExp("showuser=([0-9]*)", "g");	
	var patt2 = new RegExp("MID=([0-9]*)", "g");	
	var patt3 = new RegExp("M=([0-9]*)", "g");
    var this_url = window._content.document.location;

	
	patt1.test(gContextMenu.link.href) || patt2.test(gContextMenu.link.href) || patt3.test(gContextMenu.link.href)||
	patt1.test(this_url) || patt2.test(this_url) || patt3.test(this_url);
	var member_id = RegExp.lastParen
	
    switch (myCommand){
      case "pm":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Msg&CODE=4&MID=" + member_id;
        break;
        
      case "posts":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=getalluser&mid=" + member_id;
        break;
        
      case "contact":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Msg&CODE=02&MID=" + member_id;
        break;     
        
      case "report":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=report&mid=" + member_id;
        break;
        
      case "profile":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?showuser=" + member_id;
        break;
        
      case "garage":
        window._content.document.location.href = "http://www.gtagarage.com/users/profile.php?M=" + member_id;
        break;
        //End gtafmember
      case "link":
		GTAFcode.PutOnClipboard("[url=http://www.gtaforums.com/index.php?showuser="+member_id+"]"+gtafCode_Member_Name+"[/url]");
        break;  
        
      default : 
        var alertText = gtafCode_stringBundle.getString("gtafcode.option.err");
        alert(alertText);
        
    }
  },
gtaftopic: function(myCommand) {
	var patt1 = new RegExp("showtopic=([0-9]*)", "g");	
    var this_url = window._content.document.location;
	
	patt1.test(gContextMenu.link.href)||patt1.test(this_url);
	var topic_id = RegExp.lastParen
	
    switch (myCommand){
      case "search":
	    var searchstring = prompt("Search for");
	    if (searchstring != null ){
           window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&forums=all&result_type=posts&keywords="+searchstring+"&topic=" + topic_id;
        }
        break;
      case "subscribe":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Track&t=" + topic_id;
        break;
        
      case "print":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Print&client=choose&t=" + topic_id;
        break;
        
      case "who":
        window.open("http://www.gtaforums.com/index.php?s=&act=Stats&CODE=who&t="+topic_id, "WhoPosted", "toolbar=no,scrollbars=yes,resizable=yes,width=230,height=300");
        break;
      case "link":
		GTAFcode.PutOnClipboard("[url=http://www.gtaforums.com/index.php?showtopic="+topic_id+"]"+gtafCode_Topic_Name+"[/url]");
        break;  
        
        //End gtaftopic
        
      default : 
        var alertText = gtafCode_stringBundle.getString("gtafcode.option.err");
        alert(alertText);
        
    }
  },
gtafforum: function(myCommand) {
	var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	var forum_url = "";
	try {
		forum_url = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.href;
	} catch(e){}
	
	patt1.test(gContextMenu.link.href)||patt1.test(forum_url);
	var forum_id = RegExp.lastParen
	
    switch (myCommand){
	  case "search":
	    var searchstring = prompt("Search for");
	    if (searchstring != null ){
          window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&keywords="+searchstring+"&forums="+forum_id;
        }
        break;
      case "subscribe":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Track&type=forum&f=" + forum_id;
        break;
        
      case "mark":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Login&CODE=04&f=" + forum_id;
        break;
      case "link":
		GTAFcode.PutOnClipboard("[url=http://www.gtaforums.com/index.php?showforum="+forum_id+"]"+gtafCode_Forum_Name+"[/url]");
        break;  
        

        //End gtafforum
        
      default : 
        var alertText = gtafCode_stringBundle.getString("gtafcode.option.err");
        alert(alertText);
        
    }
  },
gtafcat: function(myCommand) {
	var patt1 = new RegExp("c=([0-9]*)", "g");	
    var this_url = window._content.document.location;
	patt1.test(gContextMenu.link.href)||patt1.test(this_url);
	var cat_id = RegExp.lastParen
	
    switch (myCommand){
	  case "search":
	    var searchstring = prompt("Search for");
	    if (searchstring != null ){
          window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&keywords="+searchstring+"&forums=c_"+cat_id;
        }
	
        break;
      case "link":
		GTAFcode.PutOnClipboard("[url=http://www.gtaforums.com/index.php?act=SC&c="+cat_id+"]"+gtafCode_Cat_Name+"[/url]");
        break;  

        //End gtafforum
        
      default : 
        var alertText = gtafCode_stringBundle.getString("gtafcode.option.err");
        alert(alertText);
        
    }
  },
gtafdefault: function(myCommand) {
	
    switch (myCommand){
      case "index":
        window._content.document.location.href = "http://www.gtaforums.com";
        break;
        
      case "posts":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=getnew";
        break;
        
      case "mark":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Login&CODE=05";
        break;
        
      case "controls":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=UserCP&CODE=00";
        break;
        
      case "inbox":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Msg&CODE=01";
        break;
        
      case "myposts":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=lastten";
        break;
        
      case "search":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search";
        break;
        
      case "searchforum":
        var patt1 = new RegExp("showforum=([0-9]*)", "g");	
	    var forum_url = window._content.document.getElementsByClassName("nav")[0].lastChild.previousSibling.href;
	    patt1.test(forum_url);
	    var forum_id = RegExp.lastParen
	    var searchstring = prompt("Search for");
	    if (searchstring != null ){	
          window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&keywords="+searchstring+"&forums="+forum_id;
        }
        break;
        
      case "searchtopic":
	    var patt1 = new RegExp("showtopic=([0-9]*)", "g");	
	
	    patt1.test(gContextMenu.link.href);
	    var topic_id = RegExp.lastParen
	    var searchstring = prompt("Search for");
	    if (searchstring != null ){
          window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=01&searchsubs=1&prune=60&prune_type=newer&forums=all&result_type=posts&keywords="+searchstring+"&topic=" + topic_id;
        }
        break;
        
      case "members":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Members";
        break;
        
      case "crew":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Stats&CODE=leaders";
        break;
        
      case "topt":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Search&CODE=getactive";
        break;
        
      case "topp":
        window._content.document.location.href = "http://www.gtaforums.com/index.php?act=Stats";
        break;
        

        //End gtafforum
        
      default : 
        var alertText = gtafCode_stringBundle.getString("gtafcode.option.err");
        alert(alertText);
        
    }
  },

  insertAtCursor_old: function(myField, myValue) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place
    if (myField.selectionStart || myField.selectionStart == '0') {
      var startPos = myField.selectionStart;
      var endPos = myField.selectionEnd;
      myField.value = myField.value.substring(0, startPos)
      + myValue
      + myField.value.substring(endPos, myField.value.length);
      var cursorPos = endPos + myValue.length;
      myField.selectionStart = cursorPos;
      myField.selectionEnd = cursorPos;
    } 
    else {
      myField.value += myValue;
    }
  },
  
  insertAtCursorEx: function(aText, bText, selection) {
	  GTAFcode.insertAtCursor(aText+bText);
      if ( selection ) {
		  GTAFcode.reselectCursor(aText+bText);
	  } else {
	      GTAFcode.backupCursor(bText);
	  }  
  },
  //Thanks to Nick for pointing out this function
  insertAtCursor: function(aText) {
    try {
      var command = "cmd_insertText";
      var controller = document.commandDispatcher.getControllerForCommand(command);
      if (controller && controller.isCommandEnabled(command)) {
        controller = controller.QueryInterface(Components.interfaces.nsICommandController);
        var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
        params = params.createInstance(Components.interfaces.nsICommandParams);
        params.setStringValue("state_data", aText);
        controller.doCommandWithParams(command, params);
      }
    }catch (e) {
      dump("Can't do cmd_insertText! ");
      dump(e+"\n")
    }
  },
  backupCursor: function(aText) {
    try {
      var command = "cmd_charPrevious";
      var controller = document.commandDispatcher.getControllerForCommand(command);
      if (controller && controller.isCommandEnabled(command)) {
        controller = controller.QueryInterface(Components.interfaces.nsICommandController);
        var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
        params = params.createInstance(Components.interfaces.nsICommandParams);
        var len = aText.length
        while( len-- > 0 ) {
	        controller.doCommand(command, params);
        }
      }
    }catch (e) {
      dump("Can't do cmd_insertText! ");
      dump(e+"\n")
    }
  },
  reselectCursor: function(aText) {
    try {
      var command = "cmd_selectCharPrevious";
      var controller = document.commandDispatcher.getControllerForCommand(command);
      if (controller && controller.isCommandEnabled(command)) {
        controller = controller.QueryInterface(Components.interfaces.nsICommandController);
        var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
        params = params.createInstance(Components.interfaces.nsICommandParams);
        var len = aText.length
        while( len-- > 0 ) {
	        controller.doCommand(command, params);
        }
      }
    }catch (e) {
      dump("Can't do cmd_insertText! ");
      dump(e+"\n")
    }
  },
    GetUserPrefs: function() {
    gtafCode_Size = getPrefgtafCodeCompose().GetCharPref("gtafcode.font.size");
    gtafCode_Color = getPrefgtafCodeCompose().GetCharPref("gtafcode.font.color");
    gtafCode_Font = getPrefgtafCodeCompose().GetCharPref("gtafcode.font.face");
  },
    PutOnClipboard: function(aText) {
		var str      = Components.classes["@mozilla.org/supports-string;1"].
		                          createInstance(Components.interfaces.nsISupportsString);
		str.data     = aText;
		
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].
		                       createInstance(Components.interfaces.nsITransferable);
		trans.addDataFlavor("text/unicode");
		trans.setTransferData("text/unicode", str, aText.length * 2);
		
		var clipid = Components.interfaces.nsIClipboard;
		var clip   = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
		clip.setData(trans, null, clipid.kGlobalClipboard);      
    }
}

//http://www.xulplanet.com/references/xpcomref/ifaces/nsIPref.html
// Definitally the best way to use prefs, set's defaults, etc.
function getPrefgtafCodeCompose() {
  if (!gPreferences) {
    try {
      gPreferences = Components.classes["@mozilla.org/preferences;1"].getService();
      gPreferences = gPreferences.QueryInterface(
        Components.interfaces.nsIPref);
    } catch (e) {}
  }

  return gPreferences;
}

//May not be needed, but just incase.
function gtafCode_setupDocument(aDoc)
{
  gtafCode_Document = aDoc;
  gtafCode_stringBundle = aDoc.getElementById("gtafcodestrings");
}

//Make sure gtafcode loads on start-up of browser.
window.addEventListener('load', GTAFcode.init, false); 
